import { IgcCancelEventArgs } from "igniteui-webcomponents-core";
/**
 * Event arguments for the editModeEntering event.
*/
export class IgcSpreadsheetEditModeEnteringEventArgs extends IgcCancelEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Returns the cell for which the control is going into edit mode.
    */
    get cell() {
        return this.i.cell;
    }
}
//# sourceMappingURL=igc-spreadsheet-edit-mode-entering-event-args.js.map
