import * as tslib_1 from "tslib";
import { IgcCancelEventArgs } from "igniteui-webcomponents-core";
/**
 * Event arguments for the editRangePasswordNeeded event.
*/
var IgcSpreadsheetEditRangePasswordNeededEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgcSpreadsheetEditRangePasswordNeededEventArgs, _super);
    function IgcSpreadsheetEditRangePasswordNeededEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgcSpreadsheetEditRangePasswordNeededEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgcSpreadsheetEditRangePasswordNeededEventArgs.prototype, "ranges", {
        /**
         * Returns the collection of protected ranges that should be unlocked.
         * This collection contains the protected ranges that overlap with the
         * locked cells that need to be unlocked. There may be multiple ranges that overlap the locked
         * cells so it may not be that every range needs to be unlocked.
        */
        get: function () {
            return this.i.ranges;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Unlocks the associated range(s) without validating the password.
    
    */
    IgcSpreadsheetEditRangePasswordNeededEventArgs.prototype.unprotect = function () {
        this.i.unprotect();
    };
    return IgcSpreadsheetEditRangePasswordNeededEventArgs;
}(IgcCancelEventArgs));
export { IgcSpreadsheetEditRangePasswordNeededEventArgs };
//# sourceMappingURL=igc-spreadsheet-edit-range-password-needed-event-args.js.map
