import { IgcCancelEventArgs } from "igniteui-webcomponents-core";
import { SpreadsheetEditModeEnteringEventArgs as SpreadsheetEditModeEnteringEventArgs_internal } from "./SpreadsheetEditModeEnteringEventArgs";
import { SpreadsheetCell } from "./SpreadsheetCell";
/**
 * Event arguments for the editModeEntering event.
*/
export declare class IgcSpreadsheetEditModeEnteringEventArgs extends IgcCancelEventArgs {
    /**
                                 * @hidden
                                 */
    readonly i: SpreadsheetEditModeEnteringEventArgs_internal;
    constructor();
    /**
     * Returns the cell for which the control is going into edit mode.
    */
    readonly cell: SpreadsheetCell;
}
