import { IgcCancelEventArgs } from "igniteui-webcomponents-core";
import { SpreadsheetHyperlinkExecutingEventArgs as SpreadsheetHyperlinkExecutingEventArgs_internal } from "./SpreadsheetHyperlinkExecutingEventArgs";
import { WorksheetHyperlink } from "igniteui-webcomponents-excel";
/**
 * Event arguments for the hyperlinkExecuting event.
*/
export declare class IgcSpreadsheetHyperlinkExecutingEventArgs extends IgcCancelEventArgs {
    /**
                                 * @hidden
                                 */
    readonly i: SpreadsheetHyperlinkExecutingEventArgs_internal;
    constructor();
    /**
     * Returns the hyperlink to be executed.
    */
    readonly hyperlink: WorksheetHyperlink;
    /**
     * Returns or sets the working directory to use when the hyperlink is a file reference.
    */
    workingDirectory: string;
}
