/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgcExcelCoreModule } from "igniteui-webcomponents-excel";
import { SpreadsheetLocaleEn } from './SpreadsheetLocaleEn';
import { UndoLocaleEn } from './UndoLocaleEn';
import { Localization } from "igniteui-webcomponents-core";
import { IgcSpreadsheetComponent } from './igc-spreadsheet-component';
export class IgcSpreadsheetCoreModule {
    static register() {
        IgcExcelCoreModule.register();
        Localization.register("undo", new UndoLocaleEn());
        Localization.register("spreadsheet", new SpreadsheetLocaleEn());
        IgcSpreadsheetComponent.register();
    }
}
//# sourceMappingURL=igc-spreadsheet-core-module.js.map
