import { Type } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare const enum WorkbookSerializationLoadCategories {
    Values = 1,
    Formulas = 2,
    SkipFormulasFromMultipleSourceRanges = 4,
    ColumnWidths = 8,
    NumberFormat = 16,
    Alignment = 32,
    Borders = 64,
    Font = 128,
    Fill = 256,
    Protection = 512,
    Style = 1024,
    UseSourceTheme = 2048,
    MergedCells = 4096,
    TableFormatting = 8192,
    RowHeights = 16384,
    IncludeColumnWidthsWithColumnSelection = 32768,
    IncludeRowHeightsWithRowSelection = 65536,
    Hyperlinks = 131072,
    Validation = 262144,
    Comments = 524288,
    FormattedStrings = 1048576,
    Tables = 2097152,
    ConditionalFormatting = 4194304,
    MergeConditionalFormatting = 8388608,
    AllGroup = 8370167,
    FormulasGroup = 3,
    ValuesGroup = 1,
    FormatsGroup = 4294640,
    CommentsGroup = 524288,
    ValidationGroup = 262144,
    AllUsingSourceThemeGroup = 8372211,
    AllExceptBordersGroup = 8370099,
    KeepSourceColumnWidthsGroup = 8304635,
    FormulasAndNumberFormatGroup = 19,
    ValuesAndNumberFormatGroup = 17,
    AllMergingConditionalFormatsGroup = 16758775
}
/**
 * @hidden
 */
export declare let WorkbookSerializationLoadCategories_$type: Type;
